MONGOEXPORT(1)

NAME
mongoexport - MongoDB Export Utility

SYNOPSIS

mongoexport is a utility that produces a JSON or CSV export of data stored in a MongoDB instance. See the http://docs.mongodb.org/manual/core/import-export document for a more in depth usage overview, and the mongoimport document for more information regarding the mongoimport utility, which provides the inverse "importing" capability.

CONSIDERATIONS

Do not use mongoimport and mongoexport for full-scale production backups because they may not reliably capture data type information. Use mongodump and mongorestore as described in http://docs.mongodb.org/manual/core/backups for this kind of functionality.

OPTIONS

Changed in version 3.0.0: mongoexport removed the --dbpath as well as related --directoryperdb and --journal options. You must use mongoexport while connected to a mongod instance.

Changed in version 3.0.0: mongoexport also removed support for writing data to tsv files with the --tsv option.

mongoexport

mongoexport

--help
    Returns information on the options and use of mongoexport.

--verbose, -v
    Increases the amount of internal reporting returned on standard output or in log files. Increase the verbosity with the -v form by including the option multiple times, (e.g. -vvvvv.)

--quiet
    Runs the mongoexport in a quiet mode that attempts to limit the amount of output.

    This option suppresses:

•   output from database commands

•   replication activity

•   connection accepted events

•   connection closed events

--version
    Returns the mongoexport release number.

--host <hostname><:port>, -h <hostname><:port>
    Default: localhost:27017

    Specifies a resolvable hostname for the mongod to which to connect. By default, the mongoexport attempts to connect to a MongoDB instance running on the localhost on port number 27017.

    To connect to a replica set, specify the replSetName and a seed list of set members, as in the following:

    <replSetName>/<hostname1><:port>,<hostname2><:port>,<...>

    You can always connect directly to a single MongoDB instance by specifying the host and port number directly.

    Changed in version 3.0.0: If you use IPv6 and use the <address>:<port> format, you must enclose the portion of an address and port combination in brackets (e.g. [<address>]).

--port <port>
    Default: 27017

    Specifies the TCP port on which the MongoDB instance listens for client connections.

--ipv6
    Enables IPv6 support and allows the mongoexport to connect to the MongoDB instance using an IPv6 network. All MongoDB programs and processes disable IPv6 support by default.

--ssl
    New in version 2.6.

    Enables connection to a mongod or mongos that has SSL support enabled.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslCAFile <filename>
    New in version 2.6.

    Specifies the .pem file that contains the root certificate chain from the Certificate Authority. Specify the file name of the .pem file using relative or absolute paths.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

    WARNING: If the mongo shell or any other tool that connects to mongos or mongod is run without --sslCAFile, it will not attempt to validate server certificates. This results in vulnerability to expired mongod and mongos certificates as well as to foreign processes posing as valid mongod or mongos instances. Ensure that you always specify the CA file against which server certificates should be validated in cases where intrusion is a possibility.

--sslPEMKeyFile <filename>
    New in version 2.6.

    Specifies the .pem file that contains both the SSL certificate and key. Specify the file name of the .pem file using relative or absolute paths.

    This option is required when using the --ssl option to connect to a mongod or mongos that has CAFile enabled without allowConnectionsWithoutCertificates.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslPEMKeyPassword <value>
    New in version 2.6.

    Specifies the password to de-crypt the certificate-key file (i.e. --sslPEMKeyFile). Use the --sslPEMKeyPassword option only if the certificate-key file is encrypted. In all cases, the mongoexport will redact the password from all logging and reporting output.

    If the private key in the PEM file is encrypted and you do not specify the --sslPEMKeyPassword option, the mongoexport will prompt for a passphrase. See ssl-certificate-password.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslCRLFile <filename>
    New in version 2.6.

    Specifies the .pem file that contains the Certificate Revocation List. Specify the file name of the .pem file using relative or absolute paths.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslAllowInvalidCertificates
    New in version 2.6.

    Bypasses the validation checks for server certificates and allows the use of invalid certificates. When using the allowInvalidCertificates setting, MongoDB logs as a warning the use of the invalid certificate.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslAllowInvalidHostnames
    New in version 3.0.

    Disables the validation of the hostnames in SSL certificates. Allows mongoexport to connect to MongoDB instances if the hostname their certificates do not match the specified hostname.

--sslFIPSMode
    New in version 2.6.

    Directs the mongoexport to use the FIPS mode of the installed OpenSSL library. Your system must have a FIPS compliant OpenSSL library to use the --sslFIPSMode option.

    NOTE: FIPS Compatible SSL is available only in MongoDB Enterprise. See http://docs.mongodb.org/manual/tutorial/configure-fips for more information.

--username <username>, -u <username>
    Specifies a username with which to authenticate to a MongoDB database that uses authentication. Use in conjunction with the --password and --authenticationDatabase options.

--password <password>, -p <password>
    Specifies a password with which to authenticate to a MongoDB database that uses authentication. Use in conjunction with the --username and --authenticationDatabase options.

    If you do not specify an argument for --password, mongoexport will prompt interactively for a password on the console.

--authenticationDatabase <dbname>
    If you do not specify an authentication database, mongoexport assumes that the database specified to export holds the user's credentials.

--authenticationMechanism <name>
    Default: MONGODB-CR

    New in version 2.4.

    Changed in version 2.6: Added support for the PLAIN and MONGODB-X509 authentication mechanisms.

    Specifies the authentication mechanism the mongoexport instance uses to authenticate to the mongod or mongos.
    Value | Description
    MONGODB-CR | MongoDB challenge/response authentication.
    MONGODB-X509 | MongoDB SSL certificate authentication.
    PLAIN | External authentication using LDAP. You can also use PLAIN for authenticating in-database users. PLAIN transmits passwords in plain text. This mechanism is available only in MongoDB Enterprise.
    GSSAPI | External authentication using Kerberos. This mechanism is available only in MongoDB Enterprise.

--gssapiServiceName
    New in version 2.6.

    Specify the name of the service using GSSAPI/Kerberos. Only required if the service does not use the default name of mongodb.

    This option is available only in MongoDB Enterprise.

--gssapiHostName
    New in version 2.6.

    Specify the hostname of a service using GSSAPI/Kerberos. Only required if the hostname of a machine does not match the hostname resolved by DNS.

    This option is available only in MongoDB Enterprise.

--db <database>, -d <database>
    Specifies the name of the database on which to run the mongoexport.

--collection <collection>, -c <collection>
    Specifies the collection to export.

--fields <field1[,field2]>, -f <field1[,field2]>
    Specifies a field or fields to include in the export. Use a comma separated list of fields to specify multiple fields.

    For csv output formats, mongoexport includes only the specified field(s), and the specified field(s) can be a field within a sub-document.

    For JSON output formats, mongoexport includes only the specified field(s) and the _id field, and if the specified field(s) is a field within a sub-document, the mongoexport includes the sub-document with all its fields, not just the specified field within the document.

--fieldFile <filename>
    An alternative to --fields. The --fieldFile option allows you to specify in a file the field or fields to include in the export and is only valid with the --type option with value csv. The file must have only one field per line, and the line(s) must end with the LF character (0x0A).

    mongoexport includes only the specified field(s). The specified field(s) can be a field within a sub-document.

--query <JSON>, -q <JSON>
    Provides a JSON document as a query that optionally limits the documents returned in the export. Specify JSON in strict format.

    For example, given a collection named records in the database test with the following documents:

    { "_id" : ObjectId("51f0188846a64a1ed98fde7c"), "a" : 1 }
    { "_id" : ObjectId("520e61b0c6646578e3661b59"), "a" : 1, "b" : 2 }
    { "_id" : ObjectId("520e642bb7fa4ea22d6b1871"), "a" : 2, "b" : 3, "c" : 5 }
    { "_id" : ObjectId("520e6431b7fa4ea22d6b1872"), "a" : 3, "b" : 3, "c" : 6 }
    { "_id" : ObjectId("520e6445b7fa4ea22d6b1873"), "a" : 5, "b" : 6, "c" : 8 }

    The following mongoexport uses the -q option to export only the documents with the field a greater than or equal to ($gte) to 3:

    mongoexport -d test -c records -q "{ a: { \$gte: 3 } }" --out exportdir/myRecords.json

    The resulting file contains the following documents:

    { "_id" : { "$oid" : "520e6431b7fa4ea22d6b1872" }, "a" : 3, "b" : 3, "c" : 6 }
    { "_id" : { "$oid" : "520e6445b7fa4ea22d6b1873" }, "a" : 5, "b" : 6, "c" : 8 }

    You can sort the results with the --sort option to mongoexport.

--type <string>
    Default: json

    New in version 3.0.0.

    Specifies the file type to export. The default format is JSON, bit it is possible to export csv files.

    If you specify csv, then you must also use either the --fields or the --fieldFile option to declare the fields to export from the collection.

--out <file>, -o <file>
    Specifies a file to write the export to. If you do not specify a file name, the mongoexport writes data to standard output (e.g. stdout).

--jsonArray
    Modifies the output of mongoexport to write the entire contents of the export as a single JSON array. By default mongoexport writes data using one JSON document for every MongoDB document.

--pretty
    New in version 3.0.0.

    Outputs documents in a pretty-printed format JSON.

--slaveOk, -k
    Allows mongoexport to read data from secondary or slave nodes when using mongoexport with a replica set. This option is only available if connected to a mongod or mongos and is not available when used with the "mongoexport --dbpath" option.

    This is the default behavior.

--forceTableScan
    New in version 2.2.

    Forces mongoexport to scan the data store directly: typically, mongoexport saves entries as they appear in the index of the _id field. Use --forceTableScan to skip the index and scan the data directly. Typically there are two cases where this behavior is preferable to the default:

1.  If you have key sizes over 800 bytes that would not be present in the _id index.

2.  Your database uses a custom _id field.

    When you run with --forceTableScan, mongoexport does not use $snapshot. As a result, the export produced by mongoexport can reflect the state of the database at many different points in time.

    WARNING: Use --forceTableScan with extreme caution and consideration.

--skip <number>
    Use --skip to control where mongoexport begins exporting documents. See skip() for information about the underlying operation.

--limit <number>
    Specifies a maximum number of documents to include in the export. See limit() for information about the underlying operation.

--sort <JSON>
    Specifies an ordering for exported results. If an index does not exist that can support the sort operation, the results must be less than 32 megabytes.

    Use --sort conjunction with --skip and --limit to limit number of exported documents.

    mongoexport -d test -c records --sort '{a: 1}' --limit 100 --out export.0.json
    mongoexport -d test -c records --sort '{a: 1}' --limit 100 --skip 100 --out export.1.json
    mongoexport -d test -c records --sort '{a: 1}' --limit 100 --skip 200 --out export.2.json

    See sort() for information about the underlying operation.

USE

  Export in CSV Format

In the following example, mongoexport exports the collection contacts from the users database from the mongod instance running on the localhost port number 27017. This command writes the export data in CSV format into a file located at /opt/backups/contacts.csv. The fields.txt file contains a line-separated list of fields to export.

mongoexport --db users --collection contacts --csv --fieldFile fields.txt --out /opt/backups/contacts.csv

  Export in JSON Format

The next example creates an export of the collection contacts from the MongoDB instance running on the localhost port number 27017, with journaling explicitly enabled. This writes the export to the contacts.json file in JSON format.

mongoexport --db sales --collection contacts --out contacts.json --journal

  Export from Remote Host Running with Authentication

The following example exports the collection contacts from the database marketing . This data resides on the MongoDB instance located on the host mongodb1.example.net running on port 37017, which requires the username user and the password pass.

mongoexport --host mongodb1.example.net --port 37017 --username user --password pass --collection contacts --db marketing --out mdb1-examplenet.json

TYPE FIDELITY

WARNING: mongoimport and mongoexport do not reliably preserve all rich BSON data types because JSON can only represent a subset of the types supported by BSON. As a result, data exported or imported with these tools may lose some measure of fidelity. See the Extended JSON reference for more information.

JSON can only represent a subset of the types supported by BSON. To preserve type information, mongoexport uses the strict mode representation for certain types.

For example, the following insert operation in the mongo shell uses the mongoShell mode representation for the BSON types data_date and data_numberlong:

use test
db.traffic.insert( { _id: 1, volume: NumberLong(2980000), date: new Date() } )

Use mongoexport to export the data:

mongoexport --db test --collection traffic --out traffic.json

The exported data is in strict mode representation to preserve type information:

{ "_id" : 1, "volume" : { "$numberLong" : "2980000" }, "date" : { "$date" : "2014-03-13T13:47:42.483-0400" } }

See http://docs.mongodb.org/manual/reference/mongodb-extended-json for a complete list of these types and the representations used.

AUTHOR
MongoDB Documentation Project

COPYRIGHT
2011-2015